import Ajax from '../../util/ajax'
import api from '../../util/api'

export default {
  namespaced: true,
  state: {
    navList: [{
      icon: '',
      name: '名著',
      id: ''
    }, {
      icon: '',
      name: '文学',
      id: ''
    }, {
      icon: '',
      name: '历史',
      id: ''
    }, {
      icon: '',
      name: '学术',
      id: ''
    }, {
      icon: '',
      name: '童话',
      id: ''
    }, {
      icon: '',
      name: '天文',
      id: ''
    }, {
      icon: '',
      name: '期刊',
      id: ''
    }, {
      icon: '',
      name: '更多',
      id: 'more'
    }],
    bookList: [{
      img: '',
      name: '书名',
      id: '',
      status: '状态',
      author: '作者',
      publishingHouses: '出版社',
      stock: '10'
    }, {
      img: '',
      name: '书名',
      id: '',
      status: '状态',
      author: '作者',
      publishingHouses: '出版社',
      stock: '10'
    }, {
      img: '',
      name: '书名',
      id: '',
      status: '状态',
      author: '作者',
      publishingHouses: '出版社',
      stock: '10'
    }, {
      img: '',
      name: '书名',
      id: '',
      status: '状态',
      author: '作者',
      publishingHouses: '出版社',
      stock: '10'
    }, {
      img: '',
      name: '书名',
      id: '',
      status: '状态',
      author: '作者',
      publishingHouses: '出版社',
      stock: '10'
    }]
  },
  mutations: {
    setNavInfo (state, data) { // 赋值nav
      (data || []).map((item) => {
        state.navList.push({
          icon: '',
          name: '历史',
          id: ''
        })
      })
    },
    emptyNavInfo (state, data) { // 清空nav
      state.navList = []
    },
    setRecommendBookList (state, data) { // 赋值精选推荐书籍列表
      (data || []).map((item) => {
        state.bookList.push({
          img: '',
          name: '书名',
          id: '',
          status: '状态',
          author: '作者',
          publishingHouses: '出版社',
          stock: '10'
        })
      })
    },
    emptyRecommendBookList (state, data) { // 清空精选推荐书籍列表
      state.bookList = []
    }
  },
  actions: {
    getNavList (context, data) { // 获取nav数据
      return new Promise((resolve, reject) => {
        Ajax(api.library.getNavList.url, {
          method: api.library.getNavList.method
        }).then(res => {
          context.commit('setNavInfo', res)
          resolve(res)
        }).catch((err) => {
          reject(err)
        })
      })
    },
    getRecommendBookList (context, data) { // 获取精选推荐书籍列表
      return new Promise((resolve, reject) => {
        Ajax(api.library.getRecommendBookList.url, {
          method: api.library.getRecommendBookList.method
        }).then(res => {
          context.commit('setRecommendBookList', res)
          resolve(res)
        }).catch((err) => {
          reject(err)
        })
      })
    }
  }
}
